;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; AI Control System


.include "entity_manager.h.s"
.include "patrol.h.s"
.include "cpctelera.h.s"
.include "game_manager.h.s"

;;IX = puntero al array de entidades
sys_ai_control_init::
;	ld (_ent_array_ptr_temp_standby), ix ;; [6]

	ld (_ent_array_ptr), ix
	ret

;;IX = puntero al array de entidades
;;A = numero elementos en arrat

sys_ai_stand_by::
	call 		man_patrol_get				;;Devuelve la patrulla segun el tipo con el que se inicializa
;;Carga el paso de patulla actual
	ld			e_ai_patrol_step_l(ix), l
	ld			e_ai_patrol_step_h(ix), h
	ld			e_ai_pre_state(ix), #e_ai_state_stand_by
	ld			e_ai_state(ix), #e_ai_state_patrol

	ret


perseguir_objetivo::
	ld a, e_countVelocityPursuers(ix)
    ld b, a
    ld a, e_maxCountVelocityPursuers(ix)
    cp b
    jr nz, _IncrementarCountVelocity

			ld 		e_vy(ix), #0

		;;Objetivo x
			ld 		a, e_xtarget(ix)			;;X objetivo en a
			sub		e_x(ix)						;;a = obj_x - x
			jr		nc, _objx_greater_or_equal	;;if (obj_x - x > 0)
		_objx_lesser:
			ld 		a, e_vxIni(ix)
			neg
			ld 		e_vx(ix), a
			jr 		_endif_x
		_objx_greater_or_equal:
			jr		z, _arrived_x
			ld 		a, e_vxIni(ix)
			ld 		e_vx(ix), a
			jr		_endif_x
		_arrived_x:
			ld 		e_vx(ix), #0
		_endif_x:

		;;Objetivo y

			ld 		a, e_ytarget(ix)			;;y objetivo en a
			sub		e_y(ix)						;;a = obj_y - y
			jr		nc, _objy_greater_or_equal	;;if (obj_y - y > 0)
		_objy_lesser:
			ld 		a, e_vyIni(ix)
			neg
			ld 		e_vy(ix), a
			jr 		_endif_y
		_objy_greater_or_equal:
			jr		z, _arrived_y
			ld 		a, e_vyIni(ix)
			ld 		e_vy(ix), a
			jr		_endif_y
		_arrived_y:
			ld 		e_vy(ix), #0
			ld		a, e_vx(ix)	;; [5]
			or 		a
			jr 		nz, _endif_y
			;;X e Y = 0
			ld		a, e_ai_pre_state(ix)					;;Coger el estado previo
			ld		e_ai_state(ix), a 						;;Se pone le estado anterior como actual
			ld		e_ai_pre_state(ix), #e_ai_state_move_to
		_endif_y:

		ld e_countVelocityPursuers(ix), #0
		jr _Salto

	_IncrementarCountVelocity:
		ld a, e_countVelocityPursuers(ix)
		inc a
		ld e_countVelocityPursuers(ix), a

	_Salto:

	ret


perseguir_jugador::
	ld 		a, e_ai_state(ix)						;;Cargar el estado del enemigo
	cp 		#e_ai_state_goToPlayer 					;;Comparar que sea el estado de perseguir al jugador
	jr 		nz, _fin
	ld		a, (banderaOut) 						;;Si lo es, se comprueba si la bandera esta cogida
	cp 		#0
	jr 		z, _fin

	ld 		a, (x_player)							;;Se le ponen como objetivo las coordenadas del jugador
	ld 		e_xtarget(ix), a
	ld		a, (y_player)
	ld 		e_ytarget(ix), a

	call	perseguir_objetivo						;;Se llama a perseguir_objetivo para ejecutar el movimiento
	ret
_fin:
	ld 		a, e_tipo_entidad(ix)
	cp 		#e_entity_enemy_pursuer
	jr 		z, _stop
	ret
_stop:
	ld 		e_vx(ix), #0
	ld 		e_vy(ix), #0
	ret

	ret

sys_ai_control_update::
ld	(_ent_conter), a

_ent_array_ptr = . + 2	;;0001 DD 21 00 00, coge el primer conjunto de 0s, que esta a dos posiciones
ld	ix, #0x0000		;; [4]
;;Bucle recorre entidades
_loop:
;;Carga el estado de la IA
ld		a, e_ai_state(ix)

cp 		#e_ai_state_noAI
jr		z, _no_AI_ent

_AI_ent:	;;Compara el estado en el que se encuentra la IA
cp 		#e_ai_state_stand_by
push 	af
ld 		a, e_patrol(ix)
call 	z, sys_ai_stand_by
pop 	af
cp 		#e_ai_state_move_to
call	z, perseguir_objetivo
cp 		#e_ai_state_patrol
call	z, mover_entre_bases
cp 		#e_ai_state_goToPlayer
call 	z, perseguir_jugador

_no_AI_ent:

_ent_conter = . +1		;;. = Direccion de memoria donde va a producir el siguiente byte
ld		a, #0		;;#0 es una variable, carga en a su valor
dec 	a
ret 	z

ld		(_ent_conter), a
;;Salto proxima entidad
ld		de, #sizeof_e
add		ix, de

jr		_loop

ret

mover_entre_bases::		;;Va a una posicion concreta
;;Carga en hl el siguiente step
	ld 		l, e_ai_patrol_step_l(ix)
	ld 		h, e_ai_patrol_step_h(ix)

;;Comprobar X != -1
	ld 		a, (hl)		;;A = X
	cp 		#patrol_invalid_move_x
	jr 		z, _reset_patrol

;;Establece las coordenadas objetivo
	ld 		e_xtarget(ix), a
	inc 	hl			;;Puntero a Y
	ld 		a, (hl)		;;A = Y
	ld 		e_ytarget(ix), a

;;Incrementa el step en + 2 (2 bytes de hl)
	inc 	hl
	ld 		e_ai_patrol_step_l(ix), l
	ld 		e_ai_patrol_step_h(ix), h

;;Cambia los estados anterior y actual
	ld 		e_ai_pre_state(ix), #e_ai_state_patrol
	ld 		e_ai_state(ix), #e_ai_state_move_to

	ret

_reset_patrol:
;;Obtener los siguientes 2 bytes de hl, que indican el inicio de la patrulla
	inc 	hl
	ld		a, (hl)
	inc 	hl
	ld 		h, (hl)

;;Reset los steps de la patrulla
	ld 		e_ai_patrol_step_l(ix), a
	ld 		e_ai_patrol_step_h(ix), h

	ret
