;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
.include "entity_manager.h.s"
.include "game_manager.h.s"
.include "cpctelera.h.s"

.globl cpct_scanKeyboard_f_asm
.globl cpct_isKeyPressed_asm


collisionSys_Init::

ret

collision_system_Update::
	call collision_system_RecoverArrays
	call collisionSys_Update_Player

	;;##CAMBIO DE COLOR DEL BORDE SEGUN BANDERA##
		ld 	 a, (colorCogido)
		cp 	 #e_color0
		jr nz, _Continue1

			cpctm_setBorder_asm #01 ;;Gris
			;;cpctm_setBorder_asm #07 ;;Color salmon
			;;cpctm_setBorder_asm #14 ;;Color negro (no queda mal)

		_Continue1:
		cp 	 #e_color1
		jr nz, _Continue2

			cpctm_setBorder_asm #25	

		_Continue2:
		cp 	 #e_color2
		jr nz, _Continue3

			cpctm_setBorder_asm #17
			;;cpctm_setBorder_asm #17 Otro azul mas claro

		_Continue3:
		cp 	 #e_color3
		ret nz
			cpctm_setBorder_asm #09


ret


collisionSys_Update_Player:
	;;############### PLAYER CON TODAS LAS ENTIDADES #####################
		_update_loop:
			ld 	c, #0 			;; C = Collisions_Counter (4=Collision)

			;;####Modificaciones variables globales y estados####

			;;##Update xyPlayer global
			ld a, e_x(iy)
			ld (x_player), a
			ld a, e_y(iy)
			ld (y_player), a

			;;##Banderas
			ld 	a, e_tipo_entidad(ix)
			cp  #e_entity_flag
			jr nz, _Continue
				ld a, (colorCogido)
				cp e_colorTipo(ix)
				jr nz, _Continue
					call collisionSys_SeguimientoBanderas ;;Para que la bandera siga al jugador cuando la coge
					call collisionSys_ComprobarBanderaEnBase ;;Para comprobar si estas en base con una bandera encima
			_Continue:
			ld 	a, e_tipo_entidad(ix) 						;;Se comprueba que el tipo de entidad sea enemigo o pursuer
			cp  #e_entity_enemy 
			call 	z, collisionSys_UpdateEnemyState 		;;Se llama al metodo que actualiza el estado del enemigo/pursuer si es necesario
			cp 	#e_entity_enemy_pursuer
			call 	z, collisionSys_UpdateEnemyState
			;; Collision in X:
			call _ifEntityLeft
			call _ifEntityRigth
			;; Collision in Y:
			call _ifEntityUp
			call _ifEntityDown

			ld 	a, c
			cp 	#4 				;;Check if is collision (3 is less down)
			jr	z,_led_on 			;; LED_ON


			push 	hl				;; Store H
			call _led_off 			;; Then LED_OFF

			pop 	hl 				;; Restore H
			dec 	h 				;; _enti_counter--
			ret 	z 				;; if 0, breack loop

			ld  	de, #sizeof_e		;; else
			add 	ix, de 			;; next entity

		jr _update_loop
	ret

	;;############### COLISION ACTIVADA #####################
		;; Collision
		_led_on:  ;;COMPROBAMOS CON QUE HA COLISIONADO EL PLAYER
			ld 	a, e_tipo_entidad(ix)
			cp  #e_entity_flag ;;Si colisiona con bandera
			call 	z, collisionPlayerFlag
			cp #e_entity_enemy
			call z, collisionPlayerEnemy
			cp #e_entity_enemy_pursuer
			call z, collisionPlayerEnemy
		ret

		;; No collision
		_led_off:

		ret


	;;############### COMPROBACION DE COLISIONES #####################
		;;Si hay 1 colision se aumenta c en 1
		_collision_on:
	    	inc 	c
		ret
		_collision_off:
			;;Nothing
		ret

		_ifEntityLeft:
			ld 	a, e_x(ix)
			add	e_w(ix)
			sub 	e_x(iy)
			jr 	z, _collision_off
			jp 	m, _collision_off
			call 	_collision_on
		ret

		_ifEntityRigth:
			ld 	a, e_x(iy)
			add 	e_w(iy)
			sub 	e_x(ix)
			jr 	z, _collision_off
			jp 	m, _collision_off
			call 	_collision_on
		ret

		_ifEntityUp:
		    	ld 	a, e_y(iy)
		    	add 	e_h(iy)
		    	ld 	b, a
		    	ld 	a, e_y(ix)
		    	sub 	b
		    	jr 	z,_collision_off
		    	jp 	p,_collision_off
		    	call 	_collision_on
		ret

		_ifEntityDown:
		    	ld 	a, e_y(ix)
		    	add 	e_h(ix)
		    	ld 	b, a
		    	ld 	a, e_y(iy)
		    	sub 	b
		    	jr 	z,_collision_off
		    	jp 	p,_collision_off
		    	call 	_collision_on
		ret

ret ;end Update Method

collisionPlayerFlag:    ;;Updateamos las variables de bandera en juego, color cogido y xyCurrentFlag segun el caso
	ld a, (banderaOut)
	cp #0
	jr nz, _FlagNoDisponible ;;Si no hay banderas fuera

	_FlagDisponible:
		call cpct_scanKeyboard_f_asm
		ld 	hl, #Key_Z
		;;DESTROY:A, D, BC, HL
		call cpct_isKeyPressed_asm
		jr 	z, E_NotPressed
		E_Pressed: ;;Si pulsamos E
			ld a, #1
			ld (banderaOut), a 			;;BanderaOut true
			ld a, e_colorTipo(ix)
			ld (colorCogido), a   		;;ColorCogido del color de la bandera cogida
		E_NotPressed:

	_FlagNoDisponible:
		;;PARA PRUEBAS: SI PULSAS F "DEJA LA BANDERA"
		call cpct_scanKeyboard_f_asm
		ld 	hl, #Key_I
		;;DESTROY:A, D, BC, HL
		call cpct_isKeyPressed_asm
		jr 	z, F_NotPressed
		F_Pressed: ;;Si pulsamos F
			ld a, #0
			ld (banderaOut), a
			ld a, #e_color0
			ld (colorCogido), a
		F_NotPressed:
ret

collisionPlayerEnemy:
	ld a, (life)
	dec a
	ld (life), a
	
	call gameMan_LoadLevel
ret


collisionSys_SeguimientoBanderas: ;;Para que la bandera siga al jugador si este la coge
	ld a, (banderaOut)
	cp #1
	jr nz, _BanderaLibre
		ld a, e_x(iy)
		ld e_x(ix), a

		ld a, e_y(iy)
		ld e_y(ix), a
	_BanderaLibre:
ret

collisionSys_ComprobarBanderaEnBase:
	ld a, (banderaOut)
	cp #1
	jp nz, _BanderaFueraDeBase
		ld a, (tocandoRojo)
		cp #1
		jr nz, _ComprobarAzul
			ld a, (colorCogido)
			cp #e_color1
			jr nz, _BanderaFueraDeBase
				ld a, #0
				ld (banderaOut), a ;;Ya no llevas bandera
				ld (tocandoRojo), a
				ld a, #e_color0
				ld (colorCogido), a ;;Color de la bandera cogida 0 porque ya no hay bandera cogida

				ld a, (banderasActualesColocadas)
				inc a
				ld (banderasActualesColocadas), a

				ld e_x(ix), #65
				ld e_y(ix), #9

				call comprobarNivelCompletado
				ret
		_ComprobarAzul:
		ld a, (tocandoAzul)
		cp #1
		jr nz, _ComprobarAmarillo
			ld a, (colorCogido)
			cp #e_color2
			jr nz, _BanderaFueraDeBase
				ld a, #0
				ld (banderaOut), a ;;Ya no llevas bandera
				ld (tocandoAzul), a
				ld a, #e_color0
				ld (colorCogido), a ;;Color de la bandera cogida 0 porque ya no hay bandera cogida

				ld a, (banderasActualesColocadas)
				inc a
				ld (banderasActualesColocadas), a

				ld e_x(ix), #69
				ld e_y(ix), #9

				call comprobarNivelCompletado
				ret
		_ComprobarAmarillo:
		ld a, (tocandoAmarillo)
		cp #1
		jr nz, _BanderaFueraDeBase
			ld a, (colorCogido)
			cp #e_color3
			jr nz, _BanderaFueraDeBase
				ld a, #0
				ld (banderaOut), a ;;Ya no llevas bandera
				ld (tocandoAmarillo), a
				ld a, #e_color0
				ld (colorCogido), a ;;Color de la bandera cogida 0 porque ya no hay bandera cogida

				ld a, (banderasActualesColocadas)
				inc a
				ld (banderasActualesColocadas), a

				ld e_x(ix), #73
				ld e_y(ix), #9

				call comprobarNivelCompletado
				ret
	_BanderaFueraDeBase:
	
ret


collisionSys_UpdateEnemyState:
	ld a, (banderaOut) 						;;Se comprueba si la bandera esta en el suelo
	cp #0
	jr z, _Patrullar 						
		ld a, (colorCogido)
		ld b, a
		ld a, e_colorTipo(ix)
		cp b
		jr nz, _Patrullar
			ld a, #e_ai_state_goToPlayer
			ld e_ai_state(ix), a
	_Patrullar:
		
ret

collision_system_RecoverArrays:
	call entityman_getEntityArray_IX
    call entityman_getNumEntities_A

	ld 	(_ent_array_ptr), 	ix 		;; Load pointer to entities array
	ld 	(_player_pointer), 	ix		;; Load Player entity
	ld 	(_ent_counter), 	a 		;; Load num of entities -1

	_ent_array_ptr = .+ 2
	ld 	ix, #0x0000 			;; |
	ld 	de, #sizeof_e			;; Next entity
	add 	ix, de 				;; Recover other entities less player

	_player_pointer = .+ 2			;; |
	ld 	iy, #0x0000 			;; Recover Player entity

	_ent_counter = .+1 			;; |
	ld 	h, #0 				;; Recover in H number of entities
	dec 	h					;; _ent_counter whithout player
ret


