;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; Manager IA
;;
.include "entity_manager.h.s"
.include "cpctelera.h.s"
.include "array_structure.h.s"
.include "entity_ai.h.s"

DefineComponentPointersArrayStructure_Size ai, max_entities

man_entity_ai_init::
;;Puntero al final del array
	ld 		hl, #_ai_ptr_array	;;Carga en hl un puntero a _ai_ptr_array
	ld 		(_ai_ptr_pend), hl

;;Pone todas las entidades a 0 para resetear partida
	xor 	a 							;;Mete un 0 en A
	ld 		(hl), a 					;;Carga en la pimera posicion el 0
	ld 		d, h 						
	ld 		e, l 						;;DE = HL + 1
	inc 	de 							
	ld 		bc, #2*max_entities-1 		;;Carga en BC los huecos no rellenados

	ldir 								;;Copia el valor de HL en DE

;;HL tiene que apuntar a la pimera posicion del array.
;;Al no poner ret en esta funcion, la siguiente funcion
;;se ejecurata despues de el init y pondra en HL
;;al principio del array de nuevo.

;;NO INSERTAR CODIGO ENTRE MEDIAS DE ESTAS FUNCIONES

man_entity_ai_getArrayHL::
	ld 		hl, #_ai_ptr_array

	ret

;;Añade entidades al array de NULLs
man_entity_ai_add::
;;Mete el contenido que hay en IX en la ultima posicion del array
	ld 		hl, (_ai_ptr_pend) 			;;Carga en HL el puntero al final del array
	ld__a_ixl							;;Carga en A el contenido de la parte baja de IX
	ld 		(hl), a 					;;Copia el contenido de A a la posiciona la que apunta HL
	inc 	hl
	ld__a_ixh 							;;Carga la parte alta
	ld 		(hl), a 					;;Copia donde apunt HL

	inc 	hl 							;;Para apuntar a la siguiente posicion
	ld (_ai_ptr_pend), hl 				;;Actualiza el puntero al final

	ret