;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; Entity Manager .H.S

;;FUNCIONES PUBLICAS
.globl entityman_getEntityArray_IX
.globl entityman_getNumEntities_A
.globl entityMan_Create
.globl entityMan_Init

																																	;;Render: 0 no se dibuja, 1 se dibuja
.macro DefineEntity _name, _x, _y, _w, _h, _vxIni, _vyIni, _vx, _vy, _color, _colorTipo, _sprite, _tipo_entidad, _render, _ai_state, _patrol, _countVelocityPursuers, _maxCountVelocityPursuers
_name::
	.db _x
	.db _y
	.db _w
	.db _h
	.db _vxIni
	.db _vyIni
	.db _vx
	.db _vy
	.db _color
	.db _colorTipo
	.db _sprite
	.db 0x00 ;;targetx
	.db 0x00 ;;targety
	.db _tipo_entidad
	.db _render
	.db _ai_state ;;ai_state
	.db _ai_state ;;ai_pre_state
	.db _patrol
	.db _countVelocityPursuers
	.db _maxCountVelocityPursuers
	.dw 0x0000         ;;ai_patrol_state
	.dw 0xCCCC		;;Almacenar la última posición de la memoria de video para borrar la entidad

.endm

;;Macro para asignar los valores de las posiciones de los atributos
__off = 0
.macro DefOffset _size, _name
	_name = __off
	__off = __off + _size
.endm

DefOffset 1, e_x
DefOffset 1, e_y
DefOffset 1, e_w
DefOffset 1, e_h
DefOffset 1, e_vxIni
DefOffset 1, e_vyIni
DefOffset 1, e_vx
DefOffset 1, e_vy
DefOffset 1, e_color
DefOffset 1, e_colorTipo
DefOffset 1, e_sprite
DefOffset 1, e_xtarget
DefOffset 1, e_ytarget
DefOffset 1, e_tipo_entidad
DefOffset 1, e_render
DefOffset 1, e_ai_state
DefOffset 1, e_ai_pre_state
DefOffset 1, e_patrol
DefOffset 1, e_countVelocityPursuers
DefOffset 1, e_maxCountVelocityPursuers
DefOffset 1, e_ai_patrol_step_l 		;;Primer byte patrulla
DefOffset 1, e_ai_patrol_step_h 		;;Segundao byte patrulla
DefOffset 1, e_lst_vmeml
DefOffset 1, e_lst_vmemh

DefOffset 0, sizeof_e ;;22


;;TIPOS DE ENTIDADES
e_entity_flag = 0
e_entity_player = 1
e_entity_enemy = 2
e_entity_enemy_pursuer = 3

;;Tipo de color
e_color0 = 0
e_color1 = 1
e_color2 = 2
e_color3 = 3


;;ESTADOS DE LA IA
e_ai_state_noAI = 0
e_ai_state_stand_by = 1 ;;No hace nada
e_ai_state_goToPlayer = 2 ;;Va a por el jugador
e_ai_state_goToFlag = 3 ;;Va a por la bandera (current target x e y)
e_ai_state_goToBase = 4 ;;Va a su base
e_ai_state_patrol = 5 ;;Se mueve entre bases
e_ai_state_move_to = 6

;;Patrullas
e_no_patrol = 0
e_patrulla1 = 1
e_patrulla2 = 2
e_patrulla3 = 3
e_patrulla4 = 4
e_patrulla5 = 5
e_patrulla6 = 6
e_patrulla7 = 7
e_patrulla8 = 8
e_patrulla9 = 9
e_patrulla10 = 10
e_patrulla11 = 11
e_patrulla12 = 12
e_patrulla13 = 13
e_patrulla14 = 14
e_patrulla15 = 15
e_patrulla16 = 16
e_patrulla17 = 17
e_patrulla18 = 18
e_patrulla19 = 19
e_patrulla20 = 20
e_patrulla21 = 21
e_patrulla22 = 22
e_patrulla23 = 23
e_patrulla24 = 24
e_patrulla25 = 25
e_patrulla26 = 26
e_patrulla27 = 27
e_patrulla28 = 28

;;Tipos de componente
;;Funciona comparando bits para saber que tipos estan activados
e_cmp_AI		= 0x01	;;0b00000001
e_cmp_Render	= 0x02	;;0b00000010
e_cmp_Physics	= 0x04	;;0b00000100
e_cmp_default	= e_cmp_Render | e_cmp_Physics 	;;Tipo por defecto
