;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; Entity Manager

.include "entity_manager.h.s"

max_entities == 11							;;Numero maximo de entidades
num_entities:: .db 0 						;; Numero actual de entidades
last_elem_ptr:: .dw entity_array			;; Puntero a la ultima posicion libre del array
entity_array:: .ds max_entities * sizeof_e		;; Reserva de memoria para las entidades: el array

entityMan_Init::
	xor a
	ld (num_entities), a

	ld bc, #entity_array
	ld (last_elem_ptr), bc
ret

entityMan_Create::
	ld 	de, (last_elem_ptr)		;;DE = apunta a la primera posicion libre del array
	ld 	bc, #sizeof_e 			;;BC = Tamanho de la entidad
	ldir 						;;Copy HL to DE, (BC size)

	ld 	a, (num_entities) 		;;
	inc 	a					;;
	ld 	(num_entities), a 		;;num_entities++

	ld 	hl, (last_elem_ptr)
	ld 	bc, #sizeof_e
	add hl, bc 					;;last_elemetn_ptrS += entity_size
	ld 	(last_elem_ptr), hl 	;;Updateamos el puntero a la sig. posicion libre del array
ret

;;Get que devuelve en ix entity_array
entityman_getEntityArray_IX::
	ld ix, #entity_array
ret

;;Get que devuelve en a num_entities
entityman_getNumEntities_A::
	ld a, (num_entities)
ret
