;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; Input System

.include "entity_manager.h.s"
.include "game_manager.h.s"
.include "cpctelera.h.s"
.globl cpct_scanKeyboard_f_asm
.globl cpct_isKeyPressed_asm

.include "map.h.s"


;;Input: IX, pointer to entity array
inputSys_Update::
	;;Reseteamos la velodidad del player
	ld e_vx(ix), #0
	ld e_vy(ix), #0

	;;Escaneamos teclado
	call cpct_scanKeyboard_f_asm ;;Updateamos el estado del teclado

	;;Chequeamos tecla "A"
	ld 	hl, #Key_O
	;;DESTROY:A, D, BC, HL
	call cpct_isKeyPressed_asm 	;; Chequeamos si A esta presionada
	jr 	z, A_NotPressed 		;;Si Key A no esta presionada
	A_Pressed:
		call mapPlayerCollision_Left
	A_NotPressed:

	;;Chequeamos tecla "D"
	ld 	hl, #Key_P
	call cpct_isKeyPressed_asm 	;
	jr 	z, D_NotPressed
	D_Pressed:
		;; Si D se ha presionado, comprobamos si hay colisión a la derecha de nuestro Player
		;; para así decirle si se puede mover a la derecha o no
		call mapPlayerCollision_Right
	D_NotPressed:

	;;Chequeamos tecla "W"
	ld 	hl, #Key_Q
	call cpct_isKeyPressed_asm 	;; Chequeamos si W esta presionada
	jr 	z, W_NotPressed 		;;Si Key W no esta presionada
	W_Pressed:
		call mapPlayerCollision_Up
	W_NotPressed:

	;;Chequeamos tecla "S"
	ld 	hl, #Key_A
	call cpct_isKeyPressed_asm
	jr 	z, S_NotPressed
	S_Pressed:
		call mapPlayerCollision_Down
	S_NotPressed:


ret
