;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; Level Manager
;; HEADERS
.include "cpctelera.h.s"
.include "render_system.h.s"
.include "entity_manager.h.s"
.include "physics_system.h.s"
.include "input_system.h.s"
.include "ai_control.h.s"
.include "collision_System.h.s"
.include "level_manager.h.s"
.include "game_manager.h.s"
.include "entity_ai.h.s"
.include "map.h.s"


;; METODOS GLOBALES
.globl cpct_drawSprite_asm
.globl cpct_getScreenPtr_asm

;; VARIABLES GLOBALES DEL SPRITE DE LAS VIDAS
.globl _g_health_3hearts
.globl _g_health_2hearts
.globl _g_health_1hearts

;Definicion de las entidades
;;PLAYER
            ;;_name, _x, _y, _w, _h,     vxIni,    vyIni,        _vx, _vy, _color, _colorTipo,      _sprite,            tipo_entidad,    render  _ai_state,     patrol      ,countVelocityPursuers, _maxCountVelocityPursuers
DefineEntity player, 30, 104, 4,   8,     0,       0,          0,   0,   0x0F,      0,              0,               e_entity_player,  1, e_ai_state_noAI, e_no_patrol,               0,                     0

;;ENEMIGOS
DefineEntity enemy1, 15, 34, 4,   8,        2,       4,          0,   0,   0xFF,      e_color0,        0,          e_entity_enemy,        1, e_ai_state_stand_by, e_patrulla1,               0,                     0
DefineEntity enemy2, 23, 182, 4,   8,     1,       2,          0,   0,   0xFF,      e_color0,        0,      e_entity_enemy,           1, e_ai_state_stand_by, e_patrulla2,               0,                     0
DefineEntity enemy3, 31, 34, 4,   8,       2,       4,          0,   0,   0xFF,      e_color0,        0,       e_entity_enemy,           1, e_ai_state_stand_by, e_patrulla3,               0,                     0
DefineEntity enemy4, 39, 182, 4,   8,     1,       2,         0,   0,   0xFF,      e_color0,        0,       e_entity_enemy,           1, e_ai_state_stand_by, e_patrulla4,               0,                     0
DefineEntity enemy5, 47, 34, 4,   8,     2,       4,          0,   0,   0xFF,      e_color0,        0,       e_entity_enemy,           1, e_ai_state_stand_by, e_patrulla5,               0,                     0
DefineEntity enemy6, 55, 182, 4,   8,     1,       2,          0,   0,   0xFF,      e_color0,        0,      e_entity_enemy,          1, e_ai_state_stand_by, e_patrulla6,               0,                     0

DefineEntity pursuer1, 55, 182, 4,   8,     1,       2,          0,   0,   0x0F,      e_color1,        0,      e_entity_enemy_pursuer,          1, e_ai_state_noAI, e_no_patrol,               0,                     5
DefineEntity pursuer2, 55, 182, 4,   8,     1,       2,          0,   0,   0xF0,      e_color2,        0,      e_entity_enemy_pursuer,          1, e_ai_state_noAI, e_no_patrol,               0,                     5
DefineEntity pursuer3, 55, 182, 4,   8,     1,       2,          0,   0,   0xFF,      e_color3,        0,      e_entity_enemy_pursuer,          1, e_ai_state_noAI, e_no_patrol,               0,                     5

;;BANDERAS
DefineEntity flag1, 7, 100, 4,   8,        0,       0,          0,   0,   0x0F,      e_color1,        0,      e_entity_flag,            1, e_ai_state_noAI, e_no_patrol,               0,                     0
DefineEntity flag2, 70, 8, 4,   8,         0,       0,          0,   0,   0xF0,      e_color2,        0,       e_entity_flag,             1, e_ai_state_noAI, e_no_patrol,               0,                     0
DefineEntity flag3, 5, 174, 4,   8,        0,       0,          0,   0,   0xFF,      e_color3,        0,       e_entity_flag,            1, e_ai_state_noAI, e_no_patrol,               0,                     0


;;ESTE Manager SE ENCARGA DE POSICIONAR LAS ENTIDADES EN LA POSICION CORRESPONDIENTE PARA CADA NIVEL
;;asi como de asignar las patrullas y velocidades correspondientes

gameMan_LoadLevel:
   ;;Variables de juego
   ld a, #0
   ld (banderaOut), a
   ld (tocandoRojo), a
   ld (tocandoAzul), a
   ld (tocandoAmarillo), a
   ld (banderasActualesColocadas), a
   ld (pressUp), a
   ld (enemiesToRender), a
   ld (flagsToRender), a
   ld (pursuersToRender), a

   ld a, #e_color0
   ld (colorCogido), a

   ld a, #1
   ld (velocity_movement), a

   ld a, #1
   ld (maxContCallPhysics), a
   ld a, #0
   ld (contCallPhysics), a
   ;;INIT IA
   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call sys_ai_control_init ;;

   call entityman_getEntityArray_IX
   call entityman_getNumEntities_A
   call entityMan_Init      ;;

   call physicsSys_Init     ;;

   call collisionSys_Init   ;;

   ;;COMPROBAMOS SI SIGUES VIVO
   ld a, (life)
   cp #0
   jr nz, _SiguesVivo ;;Si lifes = 0 has muerto
      ld bc, #state_gameOver
      ld  (game_state), bc

      ld hl, #_level_gameOver
      ld (currentLevelMap), hl

      ld hl, (currentLevelMap)
      call drawTilemap
      ret

   _SiguesVivo:


   ld a, (nivelActual)
   cp #1
   jr nz, _NextNivel1      ;;############## NIVEL 1
      call gameMan_Level1
      call entityman_getEntityArray_IX
      call entityman_getNumEntities_A
      call levelMan_PrepareLevel1
      jp _Comun
   _NextNivel1:
      cp #2
      jr nz, _NextNivel2  ;;############## NIVEL 2
         call gameMan_Level2
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel2
   _NextNivel2:
      cp #3
      jr nz, _NextNivel3   ;;############## NIVEL 3
         call gameMan_Level3
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel3
         jp _Comun
   _NextNivel3:
      cp #4
      jr nz, _NextNivel4   ;;############## NIVEL 4
         call gameMan_Level4
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel4
         jp _Comun
   _NextNivel4:
      cp #5
      jr nz, _NextNivel5   ;;############## NIVEL 5
         call gameMan_Level5
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel5
         jr _Comun
   _NextNivel5:
      cp #6
      jr nz, _NextNivel6   ;;############## NIVEL 6
         call gameMan_Level6
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel6
         jr _Comun
   _NextNivel6:
      cp #7
      jr nz, _NextNivel7   ;;############## NIVEL 7
         call gameMan_Level7
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel7
         jr _Comun
   _NextNivel7:
      cp #8
      jr nz, _NextNivel8   ;;############## NIVEL 8
         call gameMan_Level8
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel8
         jr _Comun
   _NextNivel8:
      cp #9
      jr nz, _NextNivel9   ;;############## NIVEL 9
         call gameMan_Level9
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel9
         jr _Comun
   _NextNivel9:
      cp #10
      jr nz, _NextNivel10   ;;############## NIVEL 9
         call gameMan_Level10
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel10
         jr _Comun
   _NextNivel10:
      cp #11
      jr nz, _NextNivel11   ;;############## NIVEL 9
         call gameMan_Level11
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel11
         jr _Comun
   _NextNivel11:
      cp #12
      jr nz, _NextNivel12   ;;############## NIVEL 9
         call gameMan_Level12
         call entityman_getEntityArray_IX
         call entityman_getNumEntities_A
         call levelMan_PrepareLevel12
         jr _Comun
   _NextNivel12:

   _Comun:

  ;; Dibujamos al MAPA
  ld hl, (currentLevelMap)
  call drawTilemap

  call levelMan_drawLifes
ret

levelMan_drawLifes::
   ld a, (life)
  cp #3
  jr nz, _CompruebaDosVidas

       ld    de, #0xC000    ;;Start of memory
       ld     c, #15          ;; x [0-79]
       ld     b, #10      ;;y [0-199]
       call cpct_getScreenPtr_asm

      ;; Dibujamos el sprite de las 3 vidas
       ex de, hl
       ld hl, #_g_health_3hearts
       ld c, #16
       ld b, #8
       call cpct_drawSprite_asm

   _CompruebaDosVidas:
      cp #2
      jr nz, _CompruebaUnaVida

       ld    de, #0xC000    ;;Start of memory
       ld     c, #15          ;; x [0-79]
       ld     b, #10      ;;y [0-199]
       call cpct_getScreenPtr_asm

      ;; Dibujamos el sprite de las 3 vidas
       ex de, hl
       ld hl, #_g_health_2hearts
       ld c, #16
       ld b, #8
       call cpct_drawSprite_asm
   _CompruebaUnaVida:
      cp #1
      jr nz, _Nada

       ld    de, #0xC000    ;;Start of memory
       ld     c, #15          ;; x [0-79]
       ld     b, #10      ;;y [0-199]
       call cpct_getScreenPtr_asm

      ;; Dibujamos el sprite de las 3 vidas
       ex de, hl
       ld hl, #_g_health_1hearts
       ld c, #16
       ld b, #8
       call cpct_drawSprite_asm
   _Nada:

ret

gameMan_Level1:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld a, #0
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_1
   ld (currentLevelMap), hl
ret

gameMan_Level2:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy5
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld (enemiesToRender), a

   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_2
   ld (currentLevelMap), hl
ret

gameMan_Level3:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #enemy4
   call entityMan_Create
   ld    hl, #enemy5
   call entityMan_Create
   ld    hl, #enemy6
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld a, #6
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_3
   ld (currentLevelMap), hl
ret

gameMan_Level4:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #enemy4
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld a, #4
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_4
   ld (currentLevelMap), hl
ret


gameMan_Level5:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ld    hl, #flag2
   call entityMan_Create


   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #2
   ld (flagsToRender), a
   ld a, #2
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #2
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_5
   ld (currentLevelMap), hl
ret

gameMan_Level6:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #enemy4
   call entityMan_Create
   ld    hl, #enemy5
   call entityMan_Create
   ld    hl, #enemy6
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ld    hl, #flag2
   call entityMan_Create

   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #2
   ld (flagsToRender), a
   ld a, #6
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #2
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_6
   ld (currentLevelMap), hl
ret

gameMan_Level7:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ld    hl, #flag2
   call entityMan_Create

   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #2
   ld (flagsToRender), a
   ld a, #3
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #2
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_7
   ld (currentLevelMap), hl
ret

gameMan_Level8:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #enemy4
   call entityMan_Create
   ld    hl, #enemy5
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld a, #5
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_8
   ld (currentLevelMap), hl
ret

gameMan_Level9:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #pursuer1
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld (pursuersToRender), a
   ld a, #0
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_9
   ld (currentLevelMap), hl
ret

gameMan_Level10:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #pursuer1
   call entityMan_Create
   ld    hl, #pursuer2
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ld    hl, #flag2
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #2
   ld (flagsToRender), a
   ld (pursuersToRender), a
   ld a, #0
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #2
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_10
   ld (currentLevelMap), hl
ret

gameMan_Level11:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy1
   call entityMan_Create
   ld    hl, #enemy2
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #enemy4
   call entityMan_Create
   ld    hl, #enemy5
   call entityMan_Create
   ld    hl, #enemy6
   call entityMan_Create
   ld    hl, #pursuer1
   call entityMan_Create
   ld    hl, #pursuer2
   call entityMan_Create
   ld    hl, #pursuer3
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #1
   ld (flagsToRender), a
   ld a, #6
   ld (enemiesToRender), a
   ld a, #3
   ld (pursuersToRender), a
   ;;Max BanderasEnNivel
   ld a, #1
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_11
   ld (currentLevelMap), hl
ret

gameMan_Level12:
   ;;Creamos las entidades
   ld    hl, #player
   call entityMan_Create
   ld    hl, #enemy3
   call entityMan_Create
   ld    hl, #enemy4
   call entityMan_Create
   ld    hl, #pursuer1
   call entityMan_Create
   ld    hl, #pursuer2
   call entityMan_Create
   ld    hl, #pursuer3
   call entityMan_Create
   ld    hl, #flag1
   call entityMan_Create
   ld    hl, #flag2
   call entityMan_Create
   ld    hl, #flag3
   call entityMan_Create
   ;; Guardamos el numero de enemigos/flags/power ups
   ld a, #3
   ld (flagsToRender), a
   ld (pursuersToRender), a
   ld a, #2
   ld (enemiesToRender), a
   ;;Max BanderasEnNivel
   ld a, #3
   ld (maxBanderasEnNivel), a
   ;;Cargamos el mapa del nivelActual
   ld hl, #_level_12
   ld (currentLevelMap), hl
ret

levelMan_PrepareLevel1::
   ;;No hacemos loop porque solo queremos al player
   ld e_x(ix), #37
ret

levelMan_PrepareLevel2::
   ld    b, a

   _update_loop2:
      ld a, e_tipo_entidad(ix)
      cp #e_entity_enemy
      jr nz, _NextEntity
         ld e_patrol(ix), #e_patrulla5
      _NextEntity:
      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jr    _update_loop2

ret

levelMan_PrepareLevel3::
      ld    b, a
   ld c, #-1
   _update_loop3:
      inc c
      ld a, c
      cp #0
      jr nz, _3NextEntity1 ;Player
         ld e_x(ix), #5    ;;Asignamos posicion a player
      _3NextEntity1:
      cp #1
      jr nz, _3NextEntity2 ;Enemigo 1
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _3NextEntity2:
      cp #2
      jr nz, _3NextEntity3 ;Enemigo 2

      _3NextEntity3:
      cp #3
      jr nz, _3NextEntity4 ;Enemigo 3
      _3NextEntity4:
      cp #4
      jr nz, _3NextEntity5 ;Enemigo 4
      _3NextEntity5:
      cp #5
      jr nz, _3NextEntity6 ;Enemigo 5
         
      _3NextEntity6:
      cp #6
      jr nz, _3NextEntity7 ;Enemigo 6

      _3NextEntity7:
      cp #7
      jr nz, _3NextEntity8 ;Bandera 1
         ld e_x(ix), #35   ;;Asignamos posicion a bandera
      _3NextEntity8:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jp    _update_loop3

ret



levelMan_PrepareLevel4::
   ld    b, a
   ld c, #-1
   _update_loop4:
      ld a, e_tipo_entidad(ix)
      cp #e_entity_player
      jr nz, _4NextEntity1
         ld e_x(ix), #12    ;;Asignamos posicion a player
      _4NextEntity1:
      cp #e_entity_enemy
      jr nz, _4NextEntiti2
         inc c
         ld a, c
         cp #0
         jr nz, _4NextEnemy1
            ld e_x(ix), #20      ;;Asignamos patrol y posicion al enemigo 1
            ld e_patrol(ix), #e_patrulla7
            ld e_vxIni(ix), #1
            ld e_vyIni(ix), #2
         _4NextEnemy1:
         cp #1
         jr nz, _4NextEnemy2
            ld e_x(ix), #48      ;Asignamos patrol y posicion al enemigo 2
            ld e_patrol(ix), #e_patrulla8
         _4NextEnemy2:
         cp #2
         jr nz, _4NextEnemy3
            ld e_x(ix), #24      ;Asignamos patrol y posicion al enemigo 3
            ld e_y(ix), #104
            ld e_patrol(ix), #e_patrulla10
            ld e_vxIni(ix), #1
            ld e_vyIni(ix), #2
         _4NextEnemy3:
         cp #3
         jr nz, _4NextEntiti2
            ld e_x(ix), #35      ;Asignamos patrol y posicion al enemigo 4
            ld e_y(ix), #50
            ld e_patrol(ix), #e_patrulla9
            ld e_vxIni(ix), #2
            ld e_vyIni(ix), #4
      _4NextEntiti2:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jr    _update_loop4
ret

levelMan_PrepareLevel5::
   ld    b, a
   ld c, #-1
   _update_loop5:
      inc c
      ld a, c
      cp #0
      jr nz, _5NextEntity1 ;Player
         ld e_x(ix), #38
      _5NextEntity1:
      cp #1
      jr nz, _5NextEntity2 ;Enemigo 1
         ld e_x(ix), #20
         ld e_y(ix), #138
         ld e_patrol(ix), #e_patrulla11
      _5NextEntity2:
      cp #2
      jr nz, _5NextEntity3 ;Enemigo 2
         ld e_x(ix), #54
         ld e_y(ix), #70
         ld e_patrol(ix), #e_patrulla12
         ld e_vxIni(ix), #2
         ld e_vyIni(ix), #4
      _5NextEntity3:
      cp #3
      jr nz, _5NextEntity4 ;Bandera 1
         ld e_x(ix), #33
         ld e_y(ix), #102
      _5NextEntity4:
      cp #4
      jr nz, _5NextEntity5 ;Bandera 2
         ld e_x(ix), #46
         ld e_y(ix), #102
      _5NextEntity5:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jr    _update_loop5

ret

levelMan_PrepareLevel6::
   ld    b, a
   ld c, #-1
   _update_loop6:
      inc c
      ld a, c
      cp #0
      jr nz, _6NextEntity1 ;Player
         ld e_x(ix), #37
         ld e_y(ix), #102
      _6NextEntity1:
      cp #1
      jr nz, _6NextEntity2 ;Enemigo 1
         ld e_x(ix), #30
         ld e_y(ix), #74
         ld e_patrol(ix), #e_patrulla16
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _6NextEntity2:
      cp #2
      jr nz, _6NextEntity3 ;Enemigo 2
         ld e_x(ix), #45
         ld e_y(ix), #124
         ld e_patrol(ix), #e_patrulla17
      _6NextEntity3:
      cp #3
      jr nz, _6NextEntity4 ;Enemigo 3
         ld e_x(ix), #25
         ld e_y(ix), #136
         ld e_patrol(ix), #e_patrulla18
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _6NextEntity4:
      cp #4
      jr nz, _6NextEntity5 ;Enemigo 4
         ld e_x(ix), #50
         ld e_y(ix), #62
         ld e_patrol(ix), #e_patrulla19
      _6NextEntity5:
      cp #5
      jr nz, _6NextEntity6 ;Enemigo 5
         ld e_x(ix), #20
         ld e_y(ix), #50
         ld e_patrol(ix), #e_patrulla20
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _6NextEntity6:
      cp #6
      jr nz, _6NextEntity7 ;Enemigo 6
         ld e_x(ix), #55
         ld e_y(ix), #150
         ld e_patrol(ix), #e_patrulla21
      _6NextEntity7:
      cp #7
      jr nz, _6NextEntity8 ;Bandera 1
         ld e_x(ix), #74
         ld e_y(ix), #40
      _6NextEntity8:
      cp #8
      jr nz, _6NextEntity9 ;Bandera 2
         ld e_x(ix), #5
         ld e_y(ix), #170
      _6NextEntity9:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jp    _update_loop6

ret

levelMan_PrepareLevel7::
   ld    b, a
   ld c, #-1
   _update_loop7:
      inc c
      ld a, c
      cp #0
      jr nz, _7NextEntity1 ;Player
         ld e_x(ix), #5
      _7NextEntity1:
      cp #1
      jr nz, _7NextEntity2 ;Enemigo 1
         ld e_x(ix), #12
         ld e_y(ix), #34
         ld e_patrol(ix), #e_patrulla13
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _7NextEntity2:
      cp #2
      jr nz, _7NextEntity3 ;Enemigo 2
         ld e_x(ix), #50
         ld e_y(ix), #104
         ld e_patrol(ix), #e_patrulla14
      _7NextEntity3:
      cp #3
      jr nz, _7NextEntity4 ;Enemigo 3
         ld e_x(ix), #12
         ld e_y(ix), #182
         ld e_patrol(ix), #e_patrulla15
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _7NextEntity4:
      cp #4
      jr nz, _7NextEntity5 ;Bandera 1
         ld e_x(ix), #5
         ld e_y(ix), #170
      _7NextEntity5:
      cp #5
      jr nz, _7NextEntity6 ;Bandera 2
         ld e_x(ix), #5
         ld e_y(ix), #40
      _7NextEntity6:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
   jr    _update_loop7
ret

levelMan_PrepareLevel8::
   ld    b, a
   ld c, #-1
   _update_loop8:
      inc c
      ld a, c
      cp #0
      jr nz, _8NextEntity1 ;Player
         ld e_x(ix), #27
         ld e_y(ix), #184
      _8NextEntity1:
      cp #1
      jr nz, _8NextEntity2 ;Enemigo 1
         ld e_x(ix), #44
         ld e_y(ix), #134
         ld e_patrol(ix), #e_patrulla26
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _8NextEntity2:
      cp #2
      jr nz, _8NextEntity3 ;Enemigo 2
         ld e_x(ix), #35
         ld e_y(ix), #88
         ld e_patrol(ix), #e_patrulla25
         ld e_vxIni(ix), #2
         ld e_vyIni(ix), #4
      _8NextEntity3:
      cp #3
      jr nz, _8NextEntity4 ;Enemigo 3
         ld e_x(ix), #40
         ld e_y(ix), #182
         ld e_patrol(ix), #e_patrulla24
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _8NextEntity4:
      cp #4
      jr nz, _8NextEntity5 ;Enemigo 3
         ld e_x(ix), #51
         ld e_y(ix), #30
         ld e_patrol(ix), #e_patrulla27
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _8NextEntity5:
      cp #5
      jr nz, _8NextEntity6 ;Enemigo 3
         ld e_x(ix), #3
         ld e_y(ix), #126
         ld e_patrol(ix), #e_patrulla28
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _8NextEntity6:
      cp #6
      jr nz, _8NextEntity7 ;Bandera 1
         ld e_x(ix), #12
         ld e_y(ix), #34
      _8NextEntity7:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jp    _update_loop8

ret

levelMan_PrepareLevel9::
   ld    b, a
   ld c, #-1
   _update_loop9:
      inc c
      ld a, c
      cp #0
      jr nz, _9NextEntity1 ;Player
         ld e_x(ix), #30
      _9NextEntity1:
      cp #1
      jr nz, _9NextEntity2 ;Pursuer 1 Rojo
         ld e_x(ix), #5
         ld e_y(ix), #104
      _9NextEntity2:
      cp #2
      jr nz, _9NextEntity3 ;Bandera 1 Rojo
         ld e_x(ix), #20
         ld e_y(ix), #101
      _9NextEntity3:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jr    _update_loop9

ret

levelMan_PrepareLevel10::
   ld    b, a
   ld c, #-1
   _update_loop10:
      inc c
      ld a, c
      cp #0
      jr nz, _10NextEntity1 ;Player
         ld e_x(ix), #38
      _10NextEntity1:
      cp #1
      jr nz, _10NextEntity2 ;Pursuer 1 Rojo
         ld e_x(ix), #38
         ld e_y(ix), #35
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
         ld e_maxCountVelocityPursuers(ix), #7
      _10NextEntity2:
      cp #2
      jr nz, _10NextEntity3 ;Pursuer 2 Azul
         ld e_x(ix), #38
         ld e_y(ix), #180
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
         ld e_maxCountVelocityPursuers(ix), #7
      _10NextEntity3:
      cp #3
      jr nz, _10NextEntity4 ;Bandera 1 Rojo
         ld e_x(ix), #11
         ld e_y(ix), #170
      _10NextEntity4:
      cp #4
      jr nz, _10NextEntity5 ;Bandera 2 Azul
         ld e_x(ix), #68
         ld e_y(ix), #38
      _10NextEntity5:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jr    _update_loop10

ret

levelMan_PrepareLevel11::
   ld    b, a
   ld c, #-1
   _update_loop11:
      inc c
      ld a, c
      cp #0
      jr nz, _11NextEntity1 ;Player
         ld e_x(ix), #66
      _11NextEntity1:
      cp #1
      jr nz, _11NextEntity2 ;Enemy 1
         ld e_x(ix), #23
         ld e_patrol(ix), #e_patrulla22
         ld e_vxIni(ix), #1
         ld e_vyIni(ix), #2
      _11NextEntity2:
      cp #2
      jr nz, _11NextEntity3 ;Enemy 2

      _11NextEntity3:
      cp #3
      jr nz, _11NextEntity4 ;Enemy 3

      _11NextEntity4:
      cp #4
      jr nz, _11NextEntity5 ;Enemy 4

      _11NextEntity5:
      cp #5
      jr nz, _11NextEntity6 ;Enemy 5

      _11NextEntity6:
      cp #6
      jr nz, _11NextEntity7 ;Enemy 6
         ld e_patrol(ix), #e_patrulla23
      _11NextEntity7:
      cp #7
      jr nz, _11NextEntity8 ;Pursuer 1
         ld e_x(ix), #73
         ld e_y(ix), #38
         ld e_maxCountVelocityPursuers(ix), #5
         ld e_colorTipo(ix), #e_color1
      _11NextEntity8:
      cp #8
      jr nz, _11NextEntity9 ;Pursuer 2
         ld e_x(ix), #73
         ld e_y(ix), #104
         ld e_colorTipo(ix), #e_color1
         ld e_maxCountVelocityPursuers(ix), #5
      _11NextEntity9:
      cp #9
      jr nz, _11NextEntity10 ;Pursuer 3
         ld e_x(ix), #73
         ld e_y(ix), #178
         ld e_colorTipo(ix), #e_color1
         ld e_maxCountVelocityPursuers(ix), #5
      _11NextEntity10:
      cp #10
      jr nz, _11NextEntity11 ;Bandera 1
         ld e_x(ix), #62
         ld e_y(ix), #102
      _11NextEntity11:
      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jp    _update_loop11

ret

levelMan_PrepareLevel12:
   ld    b, a
   ld c, #-1
   _update_loop12:
      inc c
      ld a, c
      cp #0
      jr nz, _12NextEntity1 ;Player
         ld e_x(ix), #20
      _12NextEntity1:
      cp #1
      jr nz, _12NextEntity2 ;Enemy 1
         ;;Enemigo numero 3
      _12NextEntity2:
      cp #2
      jr nz, _12NextEntity3 ;Enemy 2
         ;;Enemigo numero 4
      _12NextEntity3:
      cp #3
      jr nz, _12NextEntity4 ;Pursuer 1
         ld e_x(ix), #60
         ld e_y(ix), #178
         ld e_maxCountVelocityPursuers(ix), #7
      _12NextEntity4:
      cp #4
      jr nz, _12NextEntity5 ;Pursuer 2
         ld e_x(ix), #60
         ld e_y(ix), #34
         ld e_maxCountVelocityPursuers(ix), #7
      _12NextEntity5:
      cp #5
      jr nz, _12NextEntity6 ;Puruser 3
         ld e_x(ix), #72
         ld e_y(ix), #104
         ld e_maxCountVelocityPursuers(ix), #7
      _12NextEntity6:
      cp #6
      jr nz, _12NextEntity7 ;Bandera 1
         ld e_x(ix), #8
         ld e_y(ix), #38
      _12NextEntity7:
      cp #7
      jr nz, _12NextEntity8 ;Bandera 2
         ld e_x(ix), #8
         ld e_y(ix), #170
      _12NextEntity8:
      cp #8
      jr nz, _12NextEntity9 ;Bandera 3
         ld e_x(ix), #62
         ld e_y(ix), #101
      _12NextEntity9:

      ;;Looping things
      dec   b
      ret   z

      ld    de, #sizeof_e
      add   ix, de
      jp    _update_loop12
ret
