;;//-----------------------------LICENSE NOTICE------------------------------------
;;//  This file is part of U.F.O Driver
;;//  Copyright (C) 2019 Hidden Productions
;;//
;;//  This program is free software: you can redistribute it and/or modify
;;//  it under the terms of the GNU General Public License as published by
;;//  the Free Software Foundation, either version 3 of the License, or
;;//  (at your option) any later version.
;;//
;;//  This program is distributed in the hope that it will be useful,
;;//  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;//  GNU General Public License for more details.
;;//
;;//  You should have received a copy of the GNU General Public License
;;//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;//------------------------------------------------------------------------------
;;
;; System phyisics


.include "entity_manager.h.s"

screen_width = 80
screen_height = 200


physicsSys_Init::

ret	


;;Input: A:num_entities, IX:entities_array
physicsSys_Update::

	ld 	b, a 	;;load in B number of entities

	_update_loop:

		;;##UPDATE X
		ld 	a, #screen_width +1	;;(Screen Width)
		sub	e_w(ix)			
		ld 	c, a 				;;C = Screen.Width - Entity.Width 

		ld 	a, e_x(ix)			
		add 	e_vx(ix)			;; A = E_X + E_VX (Add Force)
		cp 	c 				
		jr 	nc, invalid_x 		;;if A == 0 or 1 Invalid Position


		valid_x:
			ld 	e_x(ix), a 		;; Update Position X
			jr 	endif_x 		

		invalid_x:
			ld 	a, e_vx(ix) 	;; 
			neg				;; e_vx*-1 (Reverse Velocity)
			ld 	e_vx(ix),a 		;; Update e_vx
			jr 	endif_x		
		endif_x:

		;;##UPDATE Y
		ld 	a, #screen_height +1	;;(Screen Height)
		sub 	e_h(ix)			
		ld 	c, a 			;;C = Screen.Height - Entity.Height


		ld 	a, e_y(ix)			
		add 	e_vy(ix) 		;; Add Fore Y
		cp 	c 				
		jr 	nc, invalid_y 	;;if not carry, (0 or more) invalid position


		valid_y:
			ld 	e_y(ix), a 	; Update Position Y
			jr 	endif_y	

		invalid_y:
			ld 	a, e_vy(ix)	;; 
			neg 			;;e_vy *= -1
			ld 	e_vy(ix),a 	;;Update Velocity

		endif_y:


			dec 	b 		;;num_entities--
			ret 	z		;; return if  num_entities = 0

			ld 	de, #sizeof_e ;; DE = Entity_size
			add 	ix, de 		;; IX, next entity
			jr 	_update_loop

	ret